/* ᠭ ணࠬ .   .ࠫ, "設 䨪
    ᮭ ", ., 1991, . **131.
   좮 .. - ॢ  ᪨ .

   This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 94),
   published by John Wiley, Chichester, 1987.
*/
/* CURSOR.C:      A demonstration program for cursor movements */
/*              樮 ணࠬ ६饭  */

extern int X__max, Y__max, drawmode;
int Xmin1, Xmax1, Ymin1, Ymax1, Ybottext, Xcur, Ycur, stsize=8;

main()
{ char ch;
  initgr();
  window();
  prnum(120, stsize);
  Xcur = Xmin1; Ycur = Ymin1; cur();
  prnum(200, Xcur); prnum(280, Ycur);
  while (ch = getch(), ch = toupper(ch), ch != 'Q')
  { message("       ");           /* Clear message area        */
				  /* ⪠  ᮮ饭 */
    if (ch == 0)    /* This happens if an arrow key is pressed */
	     /*  ந室  ⨨   ५ */
    { ch = getch();
      switch (ch)
      { case 75:
          cur(); Xcur -= stsize;
          if (Xcur < Xmin1) Xcur = Xmin1;
	  cur(); prnum(200, Xcur); break; /* Left  */ /*  */
        case 77:
          cur(); Xcur += stsize;
          if (Xcur > Xmax1) Xcur = Xmax1;
	  cur(); prnum(200, Xcur); break; /* Right */ /* ࠢ */
        case 72:
          cur(); Ycur -= stsize;
          if (Ycur < Ymin1) Ycur = Ymin1;
	  cur(); prnum(280, Ycur); break; /* Up    */ /*   */
        case 80:
          cur(); Ycur += stsize;
          if (Ycur > Ymax1) Ycur = Ymax1;
	  cur(); prnum(280, Ycur); break; /* Down  */ /*    */
	default: message  /* "Invalid" */
			 ("୮ " );
      }
    } else
    if (ch == '>')
    { stsize *= 2;
      if (stsize > 200) stsize = 200; /* Maximum step size = 200 */
			       /* ᨬ ࠧ 蠣 = 200 */
      prnum(120, stsize);
    } else
    if (ch == '<')
    { stsize /= 2;
      if (stsize == 0) stsize = 1;
      prnum(120, stsize);
    } else message   /* "Invalid" */
		       ("୮ " );
  }
  to_text();
}

window()
{ Xmin1 = 4; Xmax1 = X__max - 4; Ymin1 = 22; Ymax1 = Y__max - 14;
  imove(Xmin1, Ymin1); idraw(Xmax1, Ymin1); idraw(Xmax1, Ymax1);
  idraw(Xmin1, Ymax1); idraw(Xmin1, Ymin1);
  textXY(8, 0, /* "Use the four arrow keys to move the cursor." */
  "ᯮ    ५  ६饭 ,");
  imove(8, 11);
  text /* "Use > to increase, or < to decrease the stepsize." */
  (" >  㢥祭  <  㬥襭 蠣,");
  text /* "    Press Q to quit." */
       ("  Q  室");
  Ybottext = Ymax1 +3; textXY(8, Ybottext, /* "Stepsize:" */
					      " 蠣:");
  textXY(168, Ybottext, "X =");
  textXY(248, Ybottext, "Y =");
}

cur()
{ int i, j, dm;
  dm=drawmode; drawmode=0;          /* change color, using xor */
			      /*  梥 樥 XOR */
  for (j=-2; j<=2; j+=4)
  for (i=-4; i<=4; i++) dot(Xcur+i, Ycur+j);
  dot(Xcur-4, Ycur-1); dot(Xcur-3, Ycur-1);
  dot(Xcur+3, Ycur-1); dot(Xcur+4, Ycur-1);
  dot(Xcur-4, Ycur); dot(Xcur-3, Ycur); dot(Xcur+3, Ycur);
  dot(Xcur+4, Ycur);  dot(Xcur, Ycur);
  dot(Xcur-4, Ycur+1); dot(Xcur-3, Ycur+1);
  dot(Xcur+3, Ycur+1); dot(Xcur+4, Ycur+1);
  drawmode=dm;

}

prnum(X, num) int X, num;
{ char str[4];
  sprintf(str, "%3d", num); textXY(X, Ybottext, str);
}

message(str) char *str;
{ textXY(Xmax1 - 64, Ybottext, str);
}


