/* ᠭ ணࠬ .   .ࠫ, "設 䨪
    ᮭ ", ., 1991, . **159.
   좮 .. - ॢ  ᪨ .

   This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 113),
   published by John Wiley, Chichester, 1987.
*/

/* DIG.C: Drawing with Interactive Graphics        */
/*        (L. Ammeraal/John Wiley & Sons)          */
/*        This program uses functions defined in   */
/*        DIGFUN.C, DIGH.C, GRPACK.C.              */
/*                                                 */
/*        ᮢ  ࠪ⨢ ०         */
/*         ⮩ ணࠬ ᯮ 㭪樨    */
/*         㫥 DIGFUN.C, DIGH.C, GRPACK.C.   */

extern int X__max, Y__max, drawmode, colorgr;

int Xmin1, Xmax1, Ymin1, Ymax1, Xcur, Ycur, stsize=8,
    pendown, Xold, Yold, keepvector,
    Xb=100, Yb=100, Xk=100, Yk=100;
char fil[30], workstate='T';          /* T = Textmode        */
				      /* T = ⥪⮢ ० */
main(argc, argv) int argc; char **argv;
{ char ch, ch1, str[2];
  int gr_entered=0, first=1, dm, pd;
  if (argc > 1)
  { if (argv[1][0] == '-' && toupper(argv[1][1]) == 'P')
    setprdim();         /* 'setprdim' is defined in GRPACK.C */
			/* 㭪 'setprdim' ।     */
			/*  㫥  GRPACK.C                */
    else
    { printf  /* "Invalid program argument" */
	     (" 㬥 ணࠬ"); exit(1);
    }
  }
  printf  /* "File name: " */
	    (" 䠩: "); scanf("%s", fil);

  while (1)
  { if (workstate == 'T')  /* WT: textmode (= initial state) */
             /* WT:  ⥪⮢  ० (= 室 ﭨ) */

    { if (first) { ch = 'M'; first = 0; } else ch = getche();

      if (ch == 3) exit(0);    /* 3 = Ctrl-C in Turbo C      */
                               /* 3 -  樨 Ctrl-C  */
      ch = toupper(ch);
      if (ch == 'Q')
      { if (gr_entered && !colorgr)

       { printf  /* The  picture is now written to file
				       wait a moment,please. */
	       ("\n⨭ 뢠  䠩 %s;", fil);
         printf("  , .\n");
         save();
        }
        exit(0);
      }
      if (ch=='H' || ch=='M') { menu(ch); continue; }
      if (ch=='W')
      { ch1=getche(); ch1 = toupper(ch1);   /* W = Workstate */
                                    /* W - ࠡ祥 ﭨ */
        if (ch1=='A' || ch1=='L')
         /* WA: graphics alpha,  WL: line drawing and sketch */
         /* WA - 뢮 ⥪  ᪮ ०           */
         /* WL - ० 祭             */

        { wstate(ch1); gr_entered = 1; continue;
        }
      }
      menu('M'); continue;
    }

	 /* We are now in one of the two graphics workstates */
	 /*			                   WL and WA */
	 /*  ⥬     ᪨ ० - */
	 /*                                        WL  WA */
    ch=getch();
    if (ch == 0)  /* This happens if an arrow key is pressed */
           /*  ந室  ⨨   ५ */
    { ch = getch(); Xold = Xcur; Yold = Ycur;
      switch (ch)
      { case 75:
          cur(); Xcur -= stsize;
	  if (Xcur < Xmin1) Xcur = Xmin1;           /*  */
	  lseg(); cur(); prnum(192, Xcur); break;   /* Left  */
        case 77:
          cur(); Xcur += stsize;
	  if (Xcur > Xmax1) Xcur = Xmax1;          /* ࠢ */
	  lseg(); cur(); prnum(192, Xcur); break;  /* Right  */
        case 72:
          cur(); Ycur -= stsize;
	  if (Ycur < Ymin1) Ycur = Ymin1;           /*  */
	  lseg(); cur(); prnum(272, Ycur); break;   /* Up    */
        case 80:
          cur(); Ycur += stsize;
	  if (Ycur > Ymax1) Ycur = Ymax1;           /*   */
	  lseg(); cur(); prnum(272, Ycur); break;   /* Down  */
      }
      continue;
    }
    message(" ");              /* Clear the message area     */
			       /* ⪠  ᮮ饭  */
    if (workstate=='A')        /* State WA: Graphics Alpha   */
			       /*   ᪮ ० */
    { if (ch == 23)            /* 23 == Ctrl W               */
      { ch1=getch(); ch1=toupper(ch1);
        if (ch1 < 32) ch1 += 64;
			       /* Convert Ctrl-L into L etc. */
			 /* ८ࠧ Ctrl-L  L  .. */
        if (ch1 == 'L' || ch1 == 'T' || ch1 == 'A')
        { wstate(ch1); continue;
        } else message("Ctrl-W ???");
      }
      if (ch == 13)                     /* Return (or Enter) */
			       /*  Return ( Enter) */
      { penposition(0);                        /* up -  */
	cur();                           /* Erase old cursor */
					 /* ࠭  */
        Xcur = 10; Ycur += 15;
        if (Ycur > Ymax1 - 11) Ycur = Ymin1 + 1;
	cur();                           /* Draw new cursor  */
					 /*       */
        continue;
      }
      cur();                            /* delete old cursor */
				 /* 㤠 ண  */
      str[0]=(ch == 8 ? ' ' : ch);          /* 8 = backspace */
				 /* 8 -  ࠭ ᨬ */
      str[1]='\0';
      Xcur &= 0xFFF8;        /* truncated to a multiple of 8 */
			     /* 㣫  ⭮ 8    */
      if (ch == 8)
      { Xcur -= 8;
	/* space to be written on position of last character */
	/*  樨 ᫥ ᨬ   ஡   */
        if (Xcur<Xmin1) Xcur=Xmin1;
      }
      textXY(Xcur, Ycur, str);
      Xcur += (ch == 8 ? 0 : 8);
      if (Xcur>Xmax1) Xcur=Xmax1;
      cur(); coord();
      continue;
    }

       /* We are now in state WL: Line drawing and sketching */
       /*  ⥬  ﭨ WL - 稢  */
    ch = toupper(ch);
    if (ch == '>')
    { stsize *= 2;
      if (stsize > 200) stsize = 200;
				  /* Maximum step size = 200 */
			   /* ᨬ 蠣  = 200 */
      prnum(112, stsize); continue;
    }
    if (ch == '<')
    { stsize /= 2;
      if (stsize == 0) stsize = 1;
      prnum(112, stsize); continue;
    }
    if (ch == 'P')
    { ch1 = getch(); ch1 = toupper(ch1);
      switch (ch1)
      { case 'D': penposition(1); break;
        case 'U': penposition(0); break;
        case 'P': dmode(1); break;
        case 'N': dmode(-1); break;
        case 'A': dmode(0); break;
        case '0': case '1': case '2':
                hardcopy(ch1); break;
			       /* output on matrix printer   */
			       /* 뢮   ਭ */
        case 'F': cur(); pixfill(Xcur, Ycur); cur(); break;
      }
      continue;
    }

    if (ch == 'W')        /* workstate switching             */
			  /* ४祭 ࠡ祣 ﭨ */
    { ch1=getch(); ch1=toupper(ch1);
      switch (ch1)
      { case 'A': case 'L': case 'T': wstate(ch1); break;
        default: message("W ???");
      }
      continue;
    }
    dm=drawmode; pd=pendown;
    dmode(0); penposition(0);
    if (ch=='B')
    { ch1=getch(); ch1=toupper(ch1);
      switch(ch1)
      {
      case 'B':                              /* block Begin  */
					     /* 砫  */
        Xb=Xcur; Yb=Ycur;
        if (Yb>Ymin1) draw_line(Xb, Yb, Xmax1, Yb);
        if (Xb>Xmin1) draw_line(Xb, Yb, Xb, Ymax1);
        addset(Xb, Yb);
        break;
      case 'K':                              /* blocK end    */
					     /*    */
        Xk=Xcur; Yk=Ycur;
        if (Xk<Xb || Yk<Yb) break;
        if (Yb>Ymin1) draw_line(Xk, Yb, Xmax1, Yb);
        if (Xb>Xmin1) draw_line(Xb, Yk, Xb, Ymax1);
        if (Xk<Xmax1) draw_line(Xk, Yb, Xk, Yk);
        if (Yk<Ymax1) draw_line(Xb, Yk, Xk, Yk);
        dot(Xb, Yb); dot(Xk, Yk); addset(Xk, Yk);
        break;
      case 'E':                   /* Erase rectangle         */
				  /*  אַ㣮쭨 */
        if (Yb>Ymin1) draw_line(Xb, Yb, Xk, Yb);
        if (Xk<Xmax1) draw_line(Xk, Yb, Xk, Yk);
        if (Yk<Ymax1) draw_line(Xk, Yk, Xb, Yk);
        if (Xb>Xmin1) draw_line(Xb, Yk, Xb, Yb);
        break;
      case 'C':                              /* Copy block   */
					/* ஢  */
      case 'M': blcopy(ch1); break;          /* Move block   */
					/* ६饭  */
      case 'D': bldelete(); break;           /* Delete block */
					   /*   */
      case 'W': blwrite(); break;            /* Write block  */
					     /*   */
      case 'R': blread(); break;             /* Read block   */
					 /* 뢠  */
      default: message("B ???");
      }
      continue;
    }

    if (ch=='D')
	     /* define direction (DD) or unit of length (DU) */
	     /* । ࠢ       */
    { ch1=getch(); ch1=toupper(ch1);
      switch (ch1)
      { case 'D': defdirection(); break;    /* direction     */
					    /* ࠢ   */
	case 'U': unit(); break;            /* unit length   */
					    /*   */
        case 'N': newpoint(); break;
        default: message("D ???");
      }
      continue;
    }

    if (ch=='C')         /* Full circle (CF) or arc (C+, C-) */
			 /*  㦭 (CF)  㣠  */
    { ch1=getch(); ch1=toupper(ch1);
      switch (ch1)
      { case 'F': arc(0); break;
        case '+': arc(1); break;
        case '-': arc(-1); break;
        default: message("C ???");
      }
      continue;
    }

    if (ch=='S')            /* Set and sequence manipulation */
			    /* 樨  ஬ 祪   */
    { ch1=getch(); ch1=toupper(ch1);
      switch (ch1)
      { case 'A': addset(Xcur, Ycur);
	break;                   /* Add P(Xcur, Ycur) to set */
	 /*  樨  P(Xcur, Ycur)   */
	case 'C': clearset(); break;       /* Clear set      */
					   /* ⪠  */
        case 'D': delpset(Xcur, Ycur);
	break;                       /* Remove P from list   */
			       /*  窨 P   */
        case 'I': inviset(); break;
				 /* Points of set invisible  */
				  /* 窨    */
        case '[': toseq(-1); break;
				 /* To previous sequence pnt */
		   /*  ।  ᫥⥫쭮 */
        case ']': toseq(1); break;
				 /* To next sequence point   */
		    /*  ᫥  ᫥⥫쭮 */
        case '<': toseq(-2); break;
				/* To initial sequence point */
		    /*  砫  ᫥⥫쭮 */
        case '>': toseq(2); break;
				 /* To final sequence point  */
		    /*  ᫥  ᫥⥫쭮 */
        case 'F': curvefit(0); break;
				 /* B-spline curve (open)    */
			   /* ਢ -ᯫ () */
        case 'R': curvefit(1); break;
				 /* B-spline curve (closed)  */
			     /* ਢ -ᯫ () */
        default: message("S ???");
      }
      continue;
    }

    if (ch=='F') { findset(); continue; }
					/* find point in set */
				     /*  窨   */
    if (ch=='I') { ipoint(); continue; }
					/* initial point     */
					/* 砫쭠 窠   */
    if (ch=='L') { drawtoP(); continue; }
					/* draw segment      */
				     /* 稢 १ */
    if (ch=='E') { endpoint(); continue; }

    if (ch=='V')
    { ch1=getch(); ch1=toupper(ch1);
      switch (ch1)
      { case 'K': keepvector=1; break;
        case 'S': lsegment(0); break;
				 /* segment instead of arrow */
				 /* १  ५   */
        case 'D': lsegment(1); break;
				 /* dashed segment           */
				 /* 客 १        */
        case 'L': lsegment(2); break;
				 /* long line                */
				 /*  ﬠ      */
        case 'A': arrow(); break;
				 /* erase/draw arrow         */
			    /* ࠭/稢 ५ */
        default: message("V ???");
      }
      continue;
    }

    if (ch=='*') { cur(Xcur, Ycur); continue; }
					  /* toggle cursor   */
				     /* ४祭  */
    if (ch=='.') { dot(Xcur, Ycur); continue; }
					  /* toggle dot      */
				       /* ४祭 窨 */
    if (ch=='+') { icursor(Xcur, Ycur); continue; }
					  /* toggle I-cursor */
				   /* ४祭 I- */
    dmode(dm); penposition(pd);
  }
}
