/* ᠭ ணࠬ .   .ࠫ, "設 䨪
    ᮭ ", ., 1991, . **120.
   좮 .. - ॢ  ᪨ .

   This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 86),
   published by John Wiley, Chichester, 1987.
*/

/* CHARSGEN.C:  This program reads the file  CHARS.TXT,  which */
/*             displays the shapes of characters. It generates */
/*             the  program  module  CHARS.C,  containing  the */
/*             same information in coded form.                 */
/*              ணࠬ 뢠 䠩 CHARS.TXT,  */
/*             ᮤন  ᠭ .    १  㤥 */
/*             祭 ணࠬ  CHARS.C,  ᮤঠ騩 */
/*               ଠ,   ஢ .     */

#include "stdio.h"
#define NASCII 128

FILE *fpin, *fpout;

main()
{ static unsigned char chr[NASCII][11]; /* Initialized to zero */
				    /* 樠 ﬨ */
  unsigned char sym[10], k, ch;
  int s, i, j, h, l, ich, n, m;
  fpin = fopen("chars.txt", "r");
  if (fpin==NULL) { printf /* "No input file chars.txt."  */
			  (" 室 䠩 chars.txt.");
		    exit(1); }
  while (ich=getc(fpin), ich>=0)
  { n=0;
    do
    { sym[n]=ich; n++;
      skip(10);
      ich = getc(fpin);
    } while (ich != '\n');
    /*  The n characters sym[0], ..., sym[n-1] have now */
    /*  been read on one line; their tables follow!     */
    /*   ⠭ n  sym[0], ..., sym[n-1], */
    /*    ப;  ᫥  ⠡ !       */

    skipnewline /* "at the beginning of a table" */
		(" 砫 ⠡");
    for (i=0; i<11; i++)
    { for (h=0; h<n; h++)
      { s=0;
        for (j=0; j<8; j++)
        { ch=getc(fpin);
          s = 2*s + (ch == '@');
        }
        chr[sym[h]][i]=s;
        skip(3);
      }
      skipnewline /* "within a table" */
		  (" ⠡");
    }
    skipnewline /* "(first after table)" */
		  ("( ࢮ ப ᫥ ⠡)");
    skipnewline /* "(second after table)" */
		  ("( ன ப ᫥ ⠡)");
  }
  fclose(fpin);

  fpout = fopen("chars.c", "w");
  fprintf(fpout, "#define NASCII 128\n");
  fprintf(fpout, "char chlist[NASCII][11]=\n{\n ");
  for (l=0; l < NASCII - 1; l++)
  { fprintf(fpout, "{");
    m=10;
    while (m>0 && chr[l][m]==0) m--;
    /* Any zero elements following chr[l][m] can be omitted */
    /*  㫥  ᫥ chr[l][m]   饭 */
    for (i=0; i<=m; i++)
    { k=chr[l][i];
      if (k==0) putc('0', fpout); else
        fprintf(fpout, "0x%1X%1X", k>>4, k&15);
      if (i<m) fprintf(fpout, ", ");
    }
    putc('}', fpout);
    fprintf(fpout, ", ");
    if (l == 10 || l == 21) fprintf(fpout, "\n "); else
    if (l >= 31 && l < NASCII - 2)  /* Display next character: */
				   /* 뢮 ᫥饣 ᨬ */
       fprintf(fpout, "\n/*%c*/ ", l+1);
  }
  fprintf(fpout, "\n {0}};\n");
  fclose(fpout);
}

skip(n) int n;   /* Skip at most n characters of the same line */
      /* ய  ࠩ  n   ⮩  ᠬ ப */
{ int i, ch;
  for (i=0; i<n; i++)
  { ch=getc(fpin);
    if (ch=='\n') { ungetc(ch, fpin); break; }
  }
}

skipnewline(s) char *s;
	  /* Skip a newline character,  which must be present */
	  /* ய ⮩ ப ,    */
{ char ch;
  ch=getc(fpin);
  if (ch!='\n')
  { printf /* "Newline character expected " */
	   ("  ப %s", s);
  }
}