/* ᠭ ணࠬ .   .ࠫ, "設 䨪
    ᮭ ", ., 1991, . .**65
   좮 .. - ॢ  ᪨ .

   This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 43),
   published by John Wiley, Chichester, 1987.
*/
/* MOVCUR.C:                                A moving curve    */
/*                                           ਢ */

#include "time.h"

int turning;
float step;
extern int drawmode;

main()
{ int i, n, size;
  char ch, *malloc();
  float xmin=0., xmax=10., ymin=0., ymax=7., x0, y0, x, y;
  struct node { float X, Y; struct node *NEXT; } *front, *rear, *p;
  size=sizeof(struct node);
  printf /* "Step size (in inches)?" */
	 (" ࠧ 蠣 ( ): "); scanf("%f", &step);
  printf /* "How many line segments in visible curve?" */
	 ("쪮 १ אַ   ਢ? ");
	  scanf("%d", &n);
  n++;
  printf /* "Percentage of turning steps?" */
	 ("業 蠣  ⮬? "); scanf("%d", &turning);
  printf /* "Press 1 to start or resume drawing,\n\
	 2 to stop,\n\
	 3 to terminate program execution.\n" */
	 ("   :\n\
	 1 -  ᪠   祭,\n\
	 2 -  ⠭,\n\
	 3 -  襭 믮 ணࠬ.");
  do {ch=getch(); if (ch=='2'||ch=='3') exit(0);} while (ch !='1');
  x0=(xmin+xmax)/4; y0=(ymin+ymax)/2;
  front=rear=(struct node *)malloc(size);
  front->X = x0; front->Y = y0;
  initgr(); drawmode=0; i=0;
  while (1)
  { if (kbhit())
    { ch=getch();
      if (ch=='2') { while (!kbhit()); ch=getch(); }
      if (ch=='3') break;
    }
    do
    { gen(x0, y0, &x, &y);
    } while (x<xmin || x>xmax || y<ymin || y>ymax);
    move(x0, y0); draw(x, y);
    if (++i>=n)
    { p=rear; rear= p->NEXT; i=n;
      move(p->X, p->Y); draw(rear->X, rear->Y); free(p);
    }
    p=front; front=(struct node *)malloc(size); p->NEXT = front;
    front->X = x; front->Y = y; x0=x; y0=y;
  }
  endgr();
}

gen(x0, y0, px, py) float x0, y0, *px, *py;
{ int r;
  static int first=1, dir=0;
  long int seed;
  float step1;
  if (first) { first=0; time(&seed); srand((int)seed); }
  r=rand()%100;
  if (r < turning/2) dir=(++dir)%4; else
  if (r < turning) dir=(dir+=3)%4;
  step1=step*(1.+(r-50.)/100.);
	/* a distortion to avoid accidentally coinciding lines */
	/* ﭨ  砩 ᮢ             */
  switch (dir)
  { case 0: *px=x0+step1; *py=y0;       break;
    case 1: *px=x0;       *py=y0+step1; break;
    case 2: *px=x0-step1; *py=y0;       break;
    case 3: *px=x0;       *py=y0-step1; break;
  }
}


