/* ᠭ ணࠬ .   .ࠫ, "設 䨪
    ᮭ ", ., 1991, . **80.
   좮 .. - ॢ  ᪨ .

   This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 54),
   published by John Wiley, Chichester, 1987.
*/

/* This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 54),
   published by John Wiley, Chichester, 1987.
*/

/* SHADE.C:             Two spheres, displayed with shading */
/*                      ⮭ ࠦ     */

#include "stdio.h"
#include "math.h"

extern float x_max, y_max, horfact, vertfact;
extern int X__max, Y__max, drawmode, colorgr, drawmode;
int c1, c2, c3;

main()
{ int j, k, Xl, Xr, X, Yb, Yt, Y, ka, kd, ks, offset, Ika, n, i,
      I2, sq_root[1000], Id2, Id, Is, I, carry=0, cosa900,
      ix2[720], r2, ixmax2, iz2;
  float x, y, r, fy(), r0, y2, xC, yC, xmax2, xmax,
    xxC[2], yyC[2], rr[2];
  char ch, evenline[90], oddline[90], result[90];
  for (j=0; j<90; j++) { evenline[j]=0x7F; oddline[j]=0xF7; }
  printf /* "ka, kd and ks are percentages, ka + kd + ks = 100 */
	 /* "(a = ambient, d = diffuse, s = specular)          */
     ("樥 ࠦ ka, kd, ks   業.\n");
  printf(" ᮡ ᮮ⭮襭 ka + kd + ks = 100.\n");
  printf("(ka = ﭭ ᢥ, kd = 㧨, ");
  printf("ks = ઠ쭮 ࠦ)\n");
  printf /* "Enter ka: " */
	  ("\n ka: "); scanf("%d", &ka); Ika = ka * 29;
  printf /* "Enter kd: " */
	  ("\n kd: "); scanf("%d", &kd);
  printf("\n樥 ks .\n");   ks = 100 - ka - kd;
  printf /* "Enter the exponent n (n = 1, 2, ...) of Phong shading: */
	("\n ⥫ n ⮭   (n = 1,2,...): ");
  scanf("%d", &n);
  printf /* "Printed output required and printer switched on? (Y/N): */
	 ("\nॡ 뢮    祭  ਭ? (Y/N): ");
  do { ch = getchar(); ch = toupper(ch); } while (ch != 'Y' && ch != 'N');
  if (ch == 'Y') setprdim();
  xxC[0] = 0.38 * x_max; xxC[1] = 0.68 * x_max;
  yyC[0] = 0.42 * y_max; yyC[1] = 0.60 * y_max;
  rr[0] = 0.35 * y_max; rr[1] = 0.28 * y_max;
  initgr();
  if (colorgr)
  { c1=1; c2=80; c3=1;
  } else
  { c1=3; c2=90; c3=2;
  }
  /* The intensity ranges from 0 to 29.                  */
  /* The background intensity is now set.                */
  /* ⥭ᨢ ।  ।  0  29.   */
  /* 砫 ⠭ ⥭ᨢ 䮭.         */

  for (Y=0; Y<=Y__max; Y++)
  { offset = startaddress(Y); /* Address of pixel (0, Y) */
			      /*  ᥫ (0, Y) */
    poke1(0xB800, offset, (Y & 1 ? oddline : evenline), c2);
  }

  drawmode = 1;
  for (I2=0; I2<1000; I2++) sq_root[I2] = (int) (sqrt((double) I2) + 0.5);

  for (k=1; k>=0; k--)  /* k is sphere number (0 = nearer sphere) */
			/* k -   (0 =  )  */
  { r0 = rr[k];              /* Floating */ /*  饩 窮 */
    r2 = (int) (r0 * r0 + 0.5);    /* Integer */   /* 楫 ᫮ */
    r  = sqrt((double) r2);
    xC = xxC[k]; yC = yyC[k];
    for (X=IX(xC-r)-1; X <= IX(xC+r)+1; X++)
    { x = X / horfact - xC;
      ix2[X] = (int) (900.0 * x * x + 0.5);
    }
    Yt = IY(yC + r); Yb = IY(yC - r);    /* Yt < Yb */
    for (Y=Yt; Y<=Yb; Y++)
    { y = fy(Y) - yC; y2 = y * y;
      xmax2 = r2 - y2;
      if (xmax2 < 0.0) xmax2 = 0.0;
      ixmax2 = (int) (900.0 * xmax2 + 0.5);
      xmax = sqrt(xmax2);
      Xl = IX(xC - xmax); Xr = IX(xC + xmax);
      for (X=Xl; X<=Xr; X++)     /* This loop uses only integers       */
				 /*  ⮬ 横 ⮫쪮 楫 ᫠    */
      { iz2 = ixmax2 - ix2[X];   /* iz2 = 900 * z * z                  */
	Id2 = iz2/r2;            /* Square of diffuse intensity        */
				 /*  㧨 ⥭ᨢ */
        if (Id2 < 0) Id2 = 0;
	Id = sq_root[Id2];         /* Diffuse intensity = 30 cos theta */
			  /* 㧨 ⥭ᨢ = 30 cos theta */
        if (Id2 <= 450) Is = 0; else
        { cosa900 = 2 * Id2  - 900;  /* cosa900 = 900 cos alpha        */
          Is = cosa900 / 30;
          for (i=2; i<=n; i++) Is = Is * cosa900 / 900;
				  /* Exponentiation according to Phong */
				  /*   ⥯       */
        }
        I = (Ika + kd * Id + ks * Is)/100;
        carry += I;
        if (carry > 14)
        { dot(X, Y); carry -= 29;
        } else
        { drawmode = -1; dot(X, Y); drawmode = 1;
        }
      }
    }
  }
  if (ch == 'Y'&& getch())
  {         /* Reverse video: */  /* ⨢ ࠦ */
    for (Y=0; Y <= Y__max; Y++)
    { offset = startaddress(Y);
      peek1(0xB800, offset, result, c2);
      for (j=0; j<c2; j++) result[j] ^= 0xFF;
      poke1(0xB800, offset, result, c2);
    }
    printgr(0, X__max, 0, Y__max);
  }
  endgr();
}

float fy(Y) int Y; { return (Y__max-Y)/vertfact; }

int startaddress(Y) int Y; /* Start address  of pixel (0, Y) */
			   /* 砫  ᥫ (0, Y) */
{ return 0x2000*(Y&c1) + c2*(Y>>c3);
}