/* ᠭ ணࠬ .   .ࠫ, "設 䨪
    ᮭ ", ., 1991, .**136.
   좮 .. - ॢ  ᪨ .

   This program text has been copied from:
   L. Ammeraal, Computer Graphics for the IBM PC  (page 98),
   published by John Wiley, Chichester, 1987.
*/
/* SKETCH.C:     A demonstration program for sketch operations */
/*               樮 ணࠬ  ᪨஢  */

extern int X__max, Y__max, drawmode;
int Xmin1, Xmax1, Ymin1, Ymax1, Ybottext, Xcur, Ycur, stsize=8,
    pendown, Xold, Yold;

main()
{ char ch;
  initgr();
  window();
  dmode(1);        /* drawmode = 1 */  /* ० 祭 */
  penposition(0);  /* pendown = 0  */  /*     */
  prnum(120, stsize);
  Xcur = Xmin1; Ycur = Ymin1; cur();
  prnum(200, Xcur); prnum(280, Ycur);
  while (ch = getch(), ch = toupper(ch), ch != 'Q')

    { message("       ");       /* Clear message area        */
				/* ⪠  ᮮ饭 */
    if (ch == 0)  /* This happens if an arrow key is pressed */
	   /*  ந室  ⨨   ५ */
    { ch = getch(); Xold = Xcur; Yold = Ycur;
      switch (ch)
      { case 75:
          cur(); Xcur -= stsize;
          if (Xcur < Xmin1) Xcur = Xmin1;
	  lseg();  cur();
	  prnum(200, Xcur); break; /* Left  */ /*  */
        case 77:
          cur(); Xcur += stsize;
          if (Xcur > Xmax1) Xcur = Xmax1;
	  lseg(); cur();
	  prnum(200, Xcur); break; /* Right */ /* ࠢ */
        case 72:
          cur(); Ycur -= stsize;
          if (Ycur < Ymin1) Ycur = Ymin1;
	  lseg(); cur();
	  prnum(280, Ycur); break; /* Up    */ /*   */
        case 80:
          cur(); Ycur += stsize;
          if (Ycur > Ymax1) Ycur = Ymax1;
	  lseg(); cur();
	  prnum(280, Ycur); break; /* Down  */ /*    */
	default: message  /* "Invalid" */
			 ("୮ " );
      }
    } else
    if (ch == '>')
    { stsize *= 2;
      if (stsize > 200) stsize = 200; /* Maximum step size = 200 */
			       /* ᨬ ࠧ 蠣 = 200 */
      prnum(120, stsize);
    } else
    if (ch == '<')
    { stsize /= 2;
      if (stsize == 0) stsize = 1;
      prnum(120, stsize);
    } else
    if (ch == 'P')
    { ch = getch(); ch = toupper(ch);
      switch (ch)
      { case 'D': penposition(1); break;
        case 'U': penposition(0); break;
        case 'P': dmode(1); break;
        case 'N': dmode(-1); break;
        case 'A': dmode(0); break;
        default: message("P ???");
      }
    } else message   /* "Invalid" */
		       ("୮ " );
  }
  to_text();
}

window()
{ Xmin1 = 12; Xmax1 = X__max - 4; Ymin1 = 22; Ymax1 = Y__max - 14;
  imove(Xmin1, Ymin1); idraw(Xmax1, Ymin1); idraw(Xmax1, Ymax1);
  idraw(Xmin1, Ymax1); idraw(Xmin1, Ymin1);
  textXY(8, 0, /* "Use the four arrow keys to move the cursor." */
  "ᯮ    ५  ६饭 ,");
  imove(8, 11);
  text /* "Use > to increase, or < to decrease the stepsize." */
  (" >  㢥祭  <  㬥襭 蠣,");
  text /* "    Press Q to quit." */
       ("  Q  室");
  Ybottext = Ymax1 +3; textXY(8, Ybottext, /* "Stepsize:" */
					      " 蠣:");
  textXY(168, Ybottext, "X =");
  textXY(248, Ybottext, "Y =");
}

cur()
{ int i, j, dm;
  dm=drawmode; drawmode=0;          /* change color, using xor */
			      /*  梥 樥 XOR */
  for (j=-2; j<=2; j+=4)
  for (i=-4; i<=4; i++) dot(Xcur+i, Ycur+j);
  dot(Xcur-4, Ycur-1); dot(Xcur-3, Ycur-1);
  dot(Xcur+3, Ycur-1); dot(Xcur+4, Ycur-1);
  dot(Xcur-4, Ycur); dot(Xcur-3, Ycur); dot(Xcur+3, Ycur);
  dot(Xcur+4, Ycur);  dot(Xcur, Ycur);
  dot(Xcur-4, Ycur+1); dot(Xcur-3, Ycur+1);
  dot(Xcur+3, Ycur+1); dot(Xcur+4, Ycur+1);
  drawmode=dm;
}

prnum(X, num) int X, num;
{ char str[4];
  sprintf(str, "%3d", num); textXY(X, Ybottext, str);
}

message(str) char *str;
{ textXY(Xmax1 - 64, Ybottext, str);
}

lseg()
/* If pendown, draw line segment from (Xold, Yold) to (Xcur, Ycur) */
/* ᫨  饭,  稢 १ אַ       */
/* 窨 (Xold, Yold)   (Xcur, Ycur)                         */

{ static int prevdown,
      /* Was previously a line segment drawn to old point? */
      /*   ஢ १ אַ   ?    */
    prevdirection, direction;
  if (pendown)
  { draw_line(Xold, Yold, Xcur, Ycur);
    direction = Xcur < Xold ? -1 :
                Xcur > Xold ?  1 :
                Ycur < Yold ? -2 :
                Ycur > Yold ?  2 : 0;
    /* If prevdirection + direction == 0, and drawmode == 0, a line
       segment just drawn is erased; beware of an extra call of dot
       in the point of reversal, performed in  draw_line. */
    /* ᫨ ᫥饥 ᫮ 㤮⢮,  ⮫쪮  -
       祭 १ 㤠;   ⮬  室  易⥫쭮
       뢠 ⥫쭮  饭   㭪樨  dot   窥
       , 믮塞  㭪樨 draw_line.                  */

    if (prevdown && drawmode==0 && prevdirection + direction == 0)
      dot(Xold, Yold);       /* fourth call of dot in (Xold, Yold) */
			     /* ⢥⮥ 饭  㭪樨 dot  */
			     /*  窥  (Xold, Yold)              */
  }
  prevdown = pendown; prevdirection = direction;
}


penposition(p) int p;
		 /* Display pen position:  1 = down,  0 = up */
		 /* ⮡ࠦ  : 1 - 饭  */
		 /*                             0 -   */
{ int dm;
  dm=drawmode; drawmode=1;
  textXY(0, p ? 27 : 40, " ");  /* clear old pen portion */
                          /* ࠭  ண  */
  textXY(0, p ? 32 : 27, "H");
  textXY(0, p ? 40 : 35, "V");     /* a picture of a pen */
                                   /* ࠦ    */
  draw_line(0, 48, 6, 48);
                    /* the paper on which the pen writes */
                    /* 㬠,  ன       */
  pendown=p; drawmode=dm;
}

dmode(m) int m;
	 /*  1 = Positive,  -1 = Negative,  0 = Alternate    */
	 /*  1 = 祭,  -1 = ࠭,  0 = ६   */
{ textXY(0, 55, m == 1 ? "P" : m == -1 ? "N" : "A");
  drawmode = m;
}